"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.connectable = void 0;
var Subject_1 = require("../Subject");
var Observable_1 = require("../Observable");
var defer_1 = require("./defer");
function connectable(source, connector) {
    if (connector === void 0) { connector = new Subject_1.Subject(); }
    var connection = null;
    var result = new Observable_1.Observable(function (subscriber) {
        return connector.subscribe(subscriber);
    });
    result.connect = function () {
        if (!connection) {
            connection = defer_1.defer(function () { return source; }).subscribe(connector);
        }
        return connection;
    };
    return result;
}
exports.connectable = connectable;
//# sourceMappingURL=connectable.js.map