import { Subject } from '../Subject';
import { Observable } from '../Observable';
import { defer } from './defer';
export function connectable(source, connector = new Subject()) {
    let connection = null;
    const result = new Observable((subscriber) => {
        return connector.subscribe(subscriber);
    });
    result.connect = () => {
        if (!connection) {
            connection = defer(() => source).subscribe(connector);
        }
        return connection;
    };
    return result;
}
//# sourceMappingURL=connectable.js.map