import { Subject } from '../Subject';
import { Observable } from '../Observable';
import { defer } from './defer';
export function connectable(source, connector) {
    if (connector === void 0) { connector = new Subject(); }
    var connection = null;
    var result = new Observable(function (subscriber) {
        return connector.subscribe(subscriber);
    });
    result.connect = function () {
        if (!connection) {
            connection = defer(function () { return source; }).subscribe(connector);
        }
        return connection;
    };
    return result;
}
//# sourceMappingURL=connectable.js.map